<html>
<head>
<title>OGRE: Ogre::UserDefinedObject Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1UserDefinedObject.html">UserDefinedObject</a></div>
<h1>Ogre::UserDefinedObject Class Reference</h1><!-- doxytag: class="Ogre::UserDefinedObject" -->This class is designed to be subclassed by OGRE users, to allow them to associate their own application objects with <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a> instances in the engine.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreUserDefinedObject_8h-source.html">OgreUserDefinedObject.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1UserDefinedObject-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1UserDefinedObject.html#28aa9797fda94563d587cf1157fbc7dd">UserDefinedObject</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Standard constructor.  <a href="#28aa9797fda94563d587cf1157fbc7dd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1UserDefinedObject.html#b3067024e38ef17affc2599a901e5b33">~UserDefinedObject</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual long&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1UserDefinedObject.html#02bf0a62bf850493c1e968ad1993d57d">getTypeID</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return a number identifying the type of user defined object.  <a href="#02bf0a62bf850493c1e968ad1993d57d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1UserDefinedObject.html#86fa0caf4934a855fc538f1c8a56de6f">getTypeName</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return a string identifying the type of user defined object.  <a href="#86fa0caf4934a855fc538f1c8a56de6f"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class is designed to be subclassed by OGRE users, to allow them to associate their own application objects with <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a> instances in the engine. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>It's always been suggested that an OGRE application would likley comprise a number of game objects which would keep pointers to OGRE objects in order to maintain the link. However, in some cases it would be very useful to be able to navigate directly from an OGRE instance back to a custom application object. This abstract class exists for this purpose; MovableObjects hold a pointer to a <a class="el" href="classOgre_1_1UserDefinedObject.html" title="This class is designed to be subclassed by OGRE users, to allow them to associate...">UserDefinedObject</a> instance, which application writers subclass in order to include their own attributes. Your game objects themselves may be subclasses of this class, or your subclasses may merely be a link between them. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Because OGRE never uses instances of this object itself, there is very little definition to this class; the application is expected to add all the detail it wants. However, as a hint, and for debugging purposes, this class does define a 'type id', which it is recommended you use to differentiate between your subclasses, if you have more than one type. </dd></dl>

<p>Definition at line <a class="el" href="OgreUserDefinedObject_8h-source.html#l00056">56</a> of file <a class="el" href="OgreUserDefinedObject_8h-source.html">OgreUserDefinedObject.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="28aa9797fda94563d587cf1157fbc7dd"></a><!-- doxytag: member="Ogre::UserDefinedObject::UserDefinedObject" ref="28aa9797fda94563d587cf1157fbc7dd" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::UserDefinedObject::UserDefinedObject           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Standard constructor. 
<p>

</div>
</div><p>
<a class="anchor" name="b3067024e38ef17affc2599a901e5b33"></a><!-- doxytag: member="Ogre::UserDefinedObject::~UserDefinedObject" ref="b3067024e38ef17affc2599a901e5b33" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::UserDefinedObject::~UserDefinedObject           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreUserDefinedObject_8h-source.html#l00061">61</a> of file <a class="el" href="OgreUserDefinedObject_8h-source.html">OgreUserDefinedObject.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="02bf0a62bf850493c1e968ad1993d57d"></a><!-- doxytag: member="Ogre::UserDefinedObject::getTypeID" ref="02bf0a62bf850493c1e968ad1993d57d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual long Ogre::UserDefinedObject::getTypeID           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return a number identifying the type of user defined object. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Can be used to differentiate between different types of object which you attach to OGRE <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a> instances. Recommend you override this in your classes if you use more than one type of object. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Alternatively, you can override the getTypeName method and use that instead; that version is a litle more friendly and easier to scope, but obviously slightly less efficient. You choose which you prefer. </dd></dl>

</div>
</div><p>
<a class="anchor" name="86fa0caf4934a855fc538f1c8a56de6f"></a><!-- doxytag: member="Ogre::UserDefinedObject::getTypeName" ref="86fa0caf4934a855fc538f1c8a56de6f" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::UserDefinedObject::getTypeName           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Return a string identifying the type of user defined object. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Can be used to differentiate between different types of object which you attach to OGRE <a class="el" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a> instances. Recommend you override this in your classes if you use more than one type of object. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Alternatively, you can override the getTypeID method and use that instead; that version is a litle more efficient, but obviously slightly less easy to read. You choose which you prefer. </dd></dl>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreUserDefinedObject_8h-source.html">OgreUserDefinedObject.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:55:02 2008
</p>
</body>
</html>
